.186
;----------------------------------------------
;       _digit
;       input       eax = value
;       ; var       _digit_n    = cx ; digit
;       ; var       _digit_div  = bx ; div
;       output      ds:[dx] = output string
;----------------------------------------------
                PUBLIC  _digit
_digit          PROC    NEAR
                push    es
                push    si
                push    bx
                push    ds
                pop     es
                push    ax
                cmp     cx,0FFFFh
                je      Noalign
                xor     dx,dx
                mov     ax,128
                div     _digit_div
                cmp     cx,ax
                jbe     cx_ok1
                mov     cx,ax
cx_ok1:         
                cmp     cx,1
                jae     cx_ok2
                mov     cx,ax
cx_ok2:         nop
Noalign:        nop
                std
                 mov     di,offset ds:_convert$end
                 xor     bx,bx
                 mov     bx,ds:_digit_div
                 mov    al,0
                 stosb   
                pop     ax      ;   ax=value
                xor     dx,dx
_digit_ent:     
                div     bx
                mov     si,offset ds:_hextbl
                add     si,dx
                movsb
                dec     cx
                xor     dx,dx
                or      ax,ax
                jnz     _digit_ent
_digit_end:     
                cmp     cx,17
                jae     digit_err
                or      cx,cx
                jz      digit_err
                mov     al,_digit_zsup
digit_spc_loop: stosb
               loop     digit_spc_loop
digit_err:      mov     al,COLOR_ATTRIB
                stosb
                cld
                inc     di
                mov     dx,di
                pop     bx
                pop     si
                pop     es
                ret
_digit_div      DW      10
_digit_zsup     DB      ' '
_hextbl         DB      "0123456789ABCDEF"
$KetaBuf17      DB      "                 "
_convert$end    DB      0
_digit          ENDP
;----------------------------------------------
;       digitx
;----------------------------------------------
digitx          PROC    near
                pusha
                mov     COLOR_ATTRIB,0E1h
                xchg    cx,ax
                xor     ax,ax
                xchg    ax,cx
                mov     cx,4
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                call    _puts
                popa
                ret
digitx          ENDP

;----------------------------------------------
;       digitx1
;----------------------------------------------
digitx1         PROC    near
                pusha
                mov     COLOR_ATTRIB,081h
                mov     cx,1
                mov     ah,0
                call    digitxx
                popa
                ret
digitx1         ENDP

;----------------------------------------------
;       digitx2
;----------------------------------------------
digitx2         PROC    near
                pusha
                mov     COLOR_ATTRIB,0E1h
                mov     cx,2
                call    digitxx
                popa
                ret
digitx2         ENDP

;----------------------------------------------
;       digitxx
;----------------------------------------------
digitxx         PROC    near
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                call    _puts
                ret
digitxx         ENDP

;----------------------------------------------
;       digitbit
;----------------------------------------------
digitbit        PROC    near
                pusha
                mov     COLOR_ATTRIB,0E1h
                mov     cx,4
                mov     _digit_zsup,'0'
                mov     _digit_div,2
                call    _digit
                call    _puts
                popa
                ret
digitbit        ENDP
