CF_NATIVE       equ 1   ; CFꍇL
;----------------------------------------------------------------------------
; PC-9821(486) IDE BIOS patch Version 4.00 (C) 2001-06,2018-21,24 ܂
;----------------------------------------------------------------------------
NEW_ENTRY       equ     1080h
MEMseg          equ     5C00h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)
; p[^[h̒萔l(l)
MODE_M9         equ  0
MODE_MIXED_SCSI equ  1
MODE_ORTHO_SCSI equ  2
MODE_MEL_SCSI   equ  3
MODE_SSD_SCSI   equ  4
MODE_MIXED_SSD  equ  5
MODE_4G_COMPATI equ  6

; D800:2100 block is not used 
WORK_H_S         equ     2060h
WORK_HS_MUL      equ     2062h
WORK_CYL         equ     2064h ; as same as [2042h]
LocalParam       equ     2068h
LocalFlagNative  equ     2069h
USE_SYSWORK      equ     058Eh

MSG_DISP_LINE   equ     14      ; \JnsłBKXĂB
; Global stack variables -----------------
SegTVRAM        equ     word ptr [bp-4] ; T-VRAM̃ZOgA000/E000
ROW             equ     word ptr [bp-6] ; \s
COLUMN          equ     word ptr [bp-8] ; \J
COLOR_ATTRIB    equ     byte ptr [bp-10] ; \F
SwDIPSW         equ     byte ptr [bp-11]
HiresoFlag      equ     byte ptr [bp-12] ; 01h Hi-reso flag (bit 0)
AP_or_BA        equ     byte ptr [bp-13]
equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-15] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-17] ; Machine ID
MemWindowNative equ     byte ptr [bp-18] ; 08-BANK window native address
MachineType     equ     byte ptr [bp-19] ; [1]=Ap/Ae, [2]=BX/BA
WORK0457        equ     byte ptr [bp-20] ; system work area
WORK05B0        equ     byte ptr [bp-21] ; system work area

mem_bank_IOaddr equ     word ptr [bp-24] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-26] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-28] ; IDE BIOSZOgiRAMmappingj
;SegPhysIDEwork  equ     word ptr [bp-30] ; IDE work areaZOgiIj

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 103h        ; ""
DefaultModeEx   DB      01h   ; ftHg̃p[^[hliOlj;Ή
title_msg       DB      0E1h,"IDE HDDeʏgCHSp[^ύX  V4.01  @",0
machine_typeA1  DB      0E1h,"mAp,As,Aen",13,10,0
machine_typeB1  DB      041h," Ap,As,AełȂ",13,10,0
machine_typeUN  DB      0E1h,"s",13,10,0
;----------------------------------------------------------------------------
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXN̐ڑj"
CRLF_msg        DB      20h,13,10,0
msg_set         DB     0E1h,"ؽŐݒ",0
msg_param_is    DB     0E1h,"ҰӰ [",0
msg_default     DB     0E1h,"̫ ",0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_Sector256B  DB      41h,"ZN^256oCgɐݒ肳Ă܂. ",0
msg_CTRL        DB     0E1h,"CTRLĂ̂",0
msg_AvoidPatch  DB     0E1h," pb`𒆎~܂.",13,10,0
msg_CF4351_nat  DB     0A1h,"Ȳè Ұ ",0
msg_CF4351_HD   DB     0E1h,"HD݊Ұ ",0
msg_CF4351_is   DB     0E1h,"4.3GBCF ",0
msg_dsw         DB     0E1h,"(o̓foCXuިڑƯĎgpvł̐ݒ)",0
msg_msw         DB     0E1h,"iؽ 2-2 TRM/BAS modeɂݒj",0
msg_CRLF        DB     0E1h," ",13,10,0

.186
program_start:
                enter   34,0
                mov     COLOR_ATTRIB,0E1h
                mov     al,DefaultModeEx ; ftHg[hlQ
                or      al,al
                jz      @f              ; `l[łȂ!=0ꍇ
                dec     al              ; lɕϊ(-1)
         @@:    mov     ModeID,al       ; Jg[hɑ
                cld
;;;                call    ChkCPU
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
; XCb`̐ݒ݂
                mov     al,es:[3FF6h]   ; XCb`U̎w
                and     al,00000111b    ; }XN
                or      al,al           ; XCb`ÔƂftHg
                jz      NotUsedMEMSW    ; XCb`̒l͊Ol
                dec     al              ; lɕϊ(-1)
                mov     ModeID,al       ; XCb`gpȂ炻ɏ]
NotUsedMEMSW:   
                mov     al,0            ; AL=0
                mov     equip,al        ; bit̏l
                mov     AP_or_BA,al     ; =0
                mov     MachineType,al  ; =0
.386
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    ModelCheckAB    ; @풲
                pushf
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                popf
                jc      WrongMachine

                call    Scan_GRPH_FK   ; 2024-3-25 ǉidlύXj 
                jc      ToAvoid
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~
                call    Sector256Byte   ; BIOSZN^𒲍
                jc      AvoidPatch      ; CY=G[ŏI

                cmp     MachineType,0
                jz      WrongMachine
                
                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~

                call    DisplayParamMode    ; p[^[h̕\
                call    DisplayEquip
                mov     dx,offset msg_CRLF
                call    _puts

                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB

                call    AP_BA_patch     ; Ap/As/Ae  BX/BÃpb`
                jc      WrongBIOS
;                call    SetChkSum
                call    SetModeCF

                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
                call    ClearMEMseg     ; ƃNAđދ
;call Poop
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts           ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
ToAvoid:        mov     dx,offset msg_CTRL
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) Ap3,As3,BA3,BX3 only
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
                in      al,0F0h
                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOłIDE BIOS
;                jnz     IDE_absent      ; ȂƂ̂̓G[ƂȂ
                OR      equip,IDE_equip
noequip_ide:    test    al,40h          ; SCSI(A-mate)݂͑邩?
                jnz     noequip_E10_FA02        ; 2019-1-21
;                cmp     MachineType,3   ; Xe,Xs,XpI/O F0 flag bit6̈Ӗ
;                je      noequip_E10_FA02   ; Ⴄ悤Ȃ̂Œ!!
                OR      equip,E10_equip
noequip_E10_FA02:
                test    HiresoFlag,1    ; nC]Ȃ疳
                jnz     noequip_sndbios ; SOUND BIOS݂͑ȂƂ
IF 0    ; SDIPSWɂ@iA-matesj
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      noequip_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip 
ENDIF
IF 0    ; ROM̃f[^`FbNɂ@iRAMROM̔ʂ͂łȂj
                mov     ax,0CC00h
                push    es
                mov     es,ax
                mov     eax,es:[0]
                pop     es
                cmp     eax,0FFFFFFFFh  ; LROM/RAMH
                je      equip_sndbios_e
                or      eax,eax         ; 0Ŗ܂ĂRAM(UMB)
                jz      equip_sndbios_e ; ɂĂLROM͂Ȃ
                or      equip,SND_equip ;
ENDIF
IF 1    ; A-mateL̕sVXeɂ@ 2024/4/8 
                mov     dx,046Ch
                mov     al,02h
                out     dx,al
                mov     dx,0468h
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx   ; KTAœǂݏo
                mov     SwDIPSW,al
                test    al,1    ; SOUND BIOSLbit 0, ڑtL bit 2
                jNz      equip_sndbios_e ; SOUND BIOSL
                or      equip,SND_equip ;
ENDIF
equip_sndbios_e: 
noequip_sndbios:    ; SASI BIOSׂ͒ȂifBXNڑjbggp֎~j
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP

;--------------------------------------------------------
;       machines
;--------------------------------------------------------
include patch0.s
include ap_ba.s

;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ̂Ƃ
MEMtoIDEBIOS    ENDP

SetModeCF       PROC   near
                mov     dx,offset msg_CF4351_is
                call    _puts
                mov     si,offset msg_CRLF
IF 0
                mov     dx,8F1Eh        ; mod. 2024-3-24
                in      al,dx
                test    al,01000000b    ; fBXNڑjbggp=1,gpȂ=0
                mov     si,offset msg_dsw
                jnz     CF_NativeMode
ENDIF
IF 0
                mov     dx,046Ch        ; mod. 2024-4-8
                mov     al,02h          ; @\ԍH=2 Œ@
                out     dx,al
                mov     dx,0468h
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx           ; 5 IN
ENDIF
                mov     al,SwDIPSW
                test    al,00000100b    ; fBXNڑjbggp=0,gpȂ=1
                mov     si,offset msg_dsw
                jz      CF_NativeMode

                in      al,31h  ; DIP SW2-2 
                test    al,00000010b    ; 1=BASIC[h  0=^[~i[h
                mov     si,offset msg_msw
                jz      CF_NativeMode
                mov     dx,offset msg_CF4351_HD
                call    _puts
                mov     ah,0
                jmp     CF_InitMode
CF_NativeMode:  
                mov     dx,offset msg_CF4351_nat
                call    _puts
                mov     dx,si
                call    _puts
                mov     ah,1
CF_InitMode:
                mov     al,ModeID       ; AX=p[^[h̒l
                push    es
                mov     bx,0
                mov     es,bx
                mov     es:[USE_SYSWORK],ax
                pop     es
                ret
SetModeCF       ENDP

IF 1
;--------------------------------------------
;       DisplayEquip    
;--------------------------------------------
DisplayEquip    PROC   near
;                push    ROW
;                push    COLUMN
                dec     ROW
                mov     COLUMN,69
                mov     dx,offset msg_equip1
                call    _puts
                inc     ROW
                mov     COLUMN,70
                mov     dx,offset msg_equip2
                call    _puts

                mov     cl,4
                mov     ah,0
                mov     al,equip ; Internal IDE,SCSI,SND BIOS enable
                shr     al,cl
                call    digitbit
                mov     dx,offset msg_b_CRLF
                call    _puts
;                pop     COLUMN
;                pop     ROW
                ret
DisplayEquip    ENDP
msg_b_CRLF      DB     0E1h,"b",13,10,0
msg_equip1      DB     0E1h," BIOS ",0
msg_equip2      DB     0E1h,"׸ ",0
ENDIF
;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                mov     es,SegMMapIDEBIOS
                cld
                mov     cx,2000h/2      ; 8KB
                push    cx
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                push    si
                mov     ax,MEMseg
                push    ds
                mov     ds,ax   ; ds=MEMseg, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                pop     si
                pop     cx
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                mov     dx,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
                cld
                mov     cx,2000h/2      ; 8KB
                sub     si,si
                sub     di,di
                mov     ax,MEMseg
                push    ds
                mov     ds,dx   ; DS=DX=^IDE BIOSZOg
                mov     es,ax   ; ES=AX=MEMseg
          rep   movsw
                pop     ds
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE  (ex)     A-mate
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------------------------------------
;       ModelCheckAB      Ap,As,Ae  BA,BX, 
;------------------------------------------------------------
ModelCheckAB    PROC   near
                mov     al,MachineID

                cmp     al,80h  ; Ap/As/Ae H
                je      Machine_A1
                cmp     al,00h  ; Ap/As/Ae N
                je      Machine_A1
                cmp     al,0FFh ; 
                je      Machine_B1
                mov     MachineType,0
                stc
                ret
Machine_A1:     mov     MachineType,1
                clc
                ret
Machine_B1:     mov     MachineType,2
                stc
                ret
ModelCheckAB    ENDP

;------------------------------
include numeric.s     ; l\[`
.386
;include advpio.s
include putstrj3.s      ; \[`
.386
include ideptcom.s
;------------------------------
;I/O  00F0h   }VXe[^Xǂݏo^CPUVbg_E
;bit 7: CPUx聡[PC-9821ApAsAeAf]  1=High or Low, 0=Middle
;bit 6: ^Cv(SCSI)HDDXe[^X 1= 55^CvHDDȂ
;bit 5: ^Cv(IDE)HDDXe[^X 1= IDE HDDȂ
;bit 3: RAMANZX 1= W܂͊gXbg

;I/O  841Fh   DIP SWITCHǂݏo
;bit 1: SOUND BIOS   1=use SOUND BIOS  ,  0=release SOUND BIOS
;I/O  8F1Eh   DIP SWITCHǂݏo
;bit 0: 15-16MBԃVXegpL  0=system use  1=RAM use
;align 16

ProgramSize     equ     ( offset CodeEnd - offset Excode )
include excodea.s
;include excodeb.s
;-----------------------------------------
Set66h          PROC   near
                push    cx
                push    dx
                push    ax
 
                mov     dx,0642h        ;IDEreg_Feature
                mov     al,66h
                out     dx,al
                out     5Fh,al
                ;  added in V3.51

                mov     al,[bp+00]      ; drive number ͂ŎQƂ
                and     al,00000001b    ; 
                shl     al,4            ; 
                or      al,0A0h         ; 98CHS.....
                mov     dx,064Ch        ;IDEreg_SDHead
                out     dx,al
                out     5Fh,al

                mov     cx,3333h
AtaCmdLoop0:
                out     5Fh,al
                out     5Fh,al
                mov     dx,064Eh        ;IDEreg_Status
                in      al,dx
                cmp     al,50h
                je      @f
               loop     AtaCmdLoop0
        @@:
                mov     al,0EFh
                out     dx,al           ;IDEreg_Command
                mov     cx,3333h
        @@:
                out     5Fh,al
                out     5Fh,al
               loop     @b

                pop     ax
                pop     dx
                pop     cx
                ret
Set66h          ENDP

IF 1
;--------------------------------------------------------
;       Poop2
;--------------------------------------------------------
Poop2           PROC   near
                push    ax
                push    cx
                push    dx
                mov     ax,6666       ; low freq.
                call    SetTone2
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,3210h 
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    SetTone2
                pop     dx
                pop     cx
                pop     ax
                ret
Poop2           ENDP

;--------------------------------------------------------
;       SetTone2
;--------------------------------------------------------
SetTone2        PROC   near             ; ax= tone
                push    dx
                mov     DX,03FDBh       ; 3FDB
                out     DX,AL
                out     5Fh,al
                xchg    AL,AH
                out     DX,AL
                out     5Fh,al
                pop     dx
                ret
SetTone2        ENDP
ENDIF
ExCodeEnd       label byte      ; DO NOT MOVE or REMOVE
        DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
code    ends
        end     start
